--[[
File: bullet.lua
Author: Brett Lajzer
Date: 5.24.2006

About:
This is the basic bullet object.
All bullets inherit from it.
--]]


--default values
bullet = {
  angle = 0,
  speed = 0,
  x = 0, y = 0,
  collect = false
}

bullet.image, bullet.w, bullet.h = loadbmp_t("img/bullet.bmp")


--creates a new bullet
function bullet:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  return o
end


--updates a bullet's position
function bullet:update()
  self.x = self.x + (math.cos((self.angle*math.pi)/180) * self.speed)
  self.y = self.y + (math.sin((self.angle*math.pi)/180) * self.speed)

  --bounds checking (ensure it's inside the game screen)
  if self.x > s_width or self.y > s_height or self.x + self.w < 0 or self.y + self.h < 0 then
    self.collect = true
  end

end


function bullet:collide()
  self.collect = true
end


--draws a bullet
function bullet:draw()
  blit(self.image, self.x, self.y)
end