--[[
File: enemy.lua
Author: Brett Lajzer
Date: 5.25.2006

About:
This file contains the basic enemy implementation.
--]]


enemy = {}
enemy.x = 0
enemy.y = 0
enemy.angle = 0
enemy.speed = 0
enemy.step = 0
enemy.hp = 5
enemy.points = 5
enemy.collect = false
enemy.exploding = false
enemy.image, enemy.w, enemy.h = loadbmp("img/enemy.bmp")
enemy.explosion, enemy.e_w, enemy.e_h = loadbmp_t("img/explosion.bmp")
enemy.e_w = 64
enemy.e_frame = 0


function enemy:new(o)
  o = o or {}
  setmetatable(o, self)
  self.__index = self
  return o
end


function enemy:update()
  self.step = self.step + 1
  if not self.exploding then self.x = self.x + (math.cos((self.angle*math.pi)/180) * self.speed) end
  if not self.exploding then self.y = self.y + (math.sin((self.angle*math.pi)/180) * self.speed) end

  --bounds checking (ensure it's inside the game screen)
  if self.x - 100 > s_width or self.y - 100 > s_height or self.x + self.w + 100 < 0 or self.y + self.h + 100 < 0 then
    self.collect = true
  end

  --fire a bullet every 15 steps
  if not self.exploding and self.step == 15 then
    self:fire()
    self.step = 0
  end

end

function enemy:collide()
  self.hp = self.hp - 1
  if self.hp == 0 then
    self.exploding = true
    scoreboard.score = scoreboard.score + self.points
  end
end

function enemy:draw()
  blit(self.image, self.x, self.y)

  --explosion!
  if self.exploding then
    blit_frame(self.explosion, self.x + self.w/2 - self.e_w/2, self.y + self.h/2 -self.e_h/2, 6, math.floor(self.e_frame))
    self.e_frame = self.e_frame + 0.35
  end

  if self.e_frame > 6 then self.collect = true end

end


function enemy:fire()
  bullets:add(bullet:new({x = (self.x + self.w/2 - bullet.w/2), y = (self.y + self.h), angle = 90, speed = 15}))
end