--[[
File: player.lua
Author: Brett Lajzer
Date: 5.24.2006

About:
This file contains the player table.
--]]

--The Player
player = {}
player.x = 0
player.y = 0
player.lives = 3
player.lives_max = 3
player.shield = 255
player.shield_max = 255
player.image, player.w, player.h = loadbmp_t("img/player_ship.bmp")
player.bullet_image, player.bullet_w, player.bullet_h = loadimg("img/diamond_bullet.png")
player.shield_image, player.s_w, player.s_h = loadimg("img/shield.png")


function player.fire()
  player_bullets:add(bullet:new({x = (player.x + player.w/2 - bullet.w/2), y = (player.y - 16), angle = 270, speed = 15, image = player.bullet_image, w = player.bullet_w, h = player.bullet_h}))
end

function player.collide()
  player.shield = player.shield - 30
  if player.shield <= 0 then
    player.lives = player.lives - 1
    player.shield = player.shield_max
  end
end

function player.draw()

  if player.shield < player.shield_max then player.shield = player.shield + 1 end

  --draw shield
  player.s_temp, player.st_w, player.st_h = rotzoom(player.shield_image, 0, player.shield/player.shield_max)

  blit(player.s_temp, player.x + player.w/2 - player.st_w/2, player.y + player.h/2 - player.st_h/2)  

  delete_image(player.s_temp)

  --draw player
  blit(player.image, player.x, player.y)
end